package ub.pfg.preyrobot.comunications;

import android.os.Handler;
import android.os.Message;
import android.util.Log;

public class RobotInterface {
	private static final String TAG = "RobotInterface";
	
	private static RobotUtils RU = new RobotUtils();
	
	// The Handler that gets information back from the robot
    private static final Handler mHandler = new Handler() {
        @Override
        public void handleMessage( Message msg ) {
        	/*String m = (String) msg.obj;
        	if( m.equals( RU.DONE_MSG ) ) {
        		Log.i( "MSG", "MENSAJE: " + m );
        		//changeRobotState( FREE );
        	} else if( m.equals( RU.BUSY_MSG )) {
        		Log.i( "MSG", "MENSAJE: " + m );
        		//changeRobotState( BUSY );
        	}*/
        }
    };
    
	// MESSAGES
	private	byte[]		init = new byte[] {		(byte)0x09, (byte)0x00, // Bytes length (both not included)
												RU.NO_RESPONSE,			// No response expected
												(byte)0x09,				// 
												RU.INBOX,				// Inbox number
												(byte)0x05,				// Message size (including null termination)
												(byte)'i',				// Message
												(byte)'n',
												(byte)'i',
												(byte)'t',
												RU.END					// Null termination
										 },
						 movement = new byte[] {
												(byte)0x08, (byte)0x00, // Bytes length (both not included)
												RU.NO_RESPONSE,			// No response expected
												(byte)0x09,				// 
												RU.INBOX,				// Inbox number
												(byte)0x04,				// Message size (including null termination)
												(byte)0x00,				// Message
												(byte)0x00,
												(byte)0x00,
												RU.END					// Null termination
										 };
	
	private BluetoothCom comManager = null;
	
	public RobotInterface() {
		comManager = BluetoothCom.getInstance();
		comManager.setHandler( mHandler );
	}
	
	public void sendInit() {
		comManager.write( init );
	}
	
	public void sendProportionalMovement( byte direction, int factor ) {
		Log.i( TAG, "DATA: "+factor );
		int lower = factor % 10;
		int upper = (int)factor/10;
		
		String a = Integer.toString( upper ); 
		String b = Integer.toString( lower );
		Log.i( TAG, "INT UPPER: "+a.charAt(0) );
		Log.i( TAG, "INT LOWER: "+b.charAt(0) );
		
		movement[RU.MESSAGE] = direction;
		movement[RU.MESSAGE+1] = (byte)a.charAt(0);
		movement[RU.MESSAGE+2] = (byte)b.charAt(0);
		comManager.write( movement );
	}
	
	public void stop() {
		comManager.stopConection();
	}
	
}
