package ub.pfg.preyrobot.vision;

import org.opencv.core.Mat;
import org.opencv.core.Size;
import org.opencv.highgui.Highgui;
import org.opencv.imgproc.Imgproc;
import android.os.Environment;
import android.util.Log;

public class ORBTracker extends Tracker {
	private static final String TAG = "Tracker";
	
	private FeatureMatcher 		myDetector;
	private Mat 				m, gray;
	
	private String 				path = Environment.getExternalStorageDirectory()+"/nxt.jpg"; // cubo.png
	
	// State of this processor
	private static final int 	FREE = 0,
								BUSY = 1;
	
	private int 				internalState;
	
	
	public void initDetector() {
		super.initDetector();
		
		myDetector = new FeatureMatcher();
		myDetector.enableDebug();
		gray = new Mat();
		
		internalState = FREE;
		
		Mat aux = Highgui.imread( path, Imgproc.COLOR_RGB2GRAY );
		Imgproc.resize( aux, myDetector.trainImage, new Size(300,480) );

		myDetector.computePrevDescriptor( false );
	}
	
	public Mat processFrame( Mat m ) {
		Log.i( TAG, "PROCESANDO FRAME" );
		internalState = BUSY;
		
		Mat aux = new Mat();
		Imgproc.cvtColor( m, aux, Imgproc.COLOR_RGB2GRAY, 0 );
		Imgproc.resize( aux, gray, new Size(500, 480) );
		
		if( myDetector.detectAndMatching( gray ) ) {
			return myDetector.matching;
		}
		
		/*if( myDetector.detectAndKnnMatching( gray ) ) {
			//Log.i( TAG, "----------MATCHING---------" );
			//Log.i( TAG, "COLS: "+ myDetector.matching.cols() );
			//Log.i( TAG, "ROWS: "+ myDetector.matching.rows() );
			return myDetector.matching;
		}*/
		
		internalState = FREE;
		//Features2d.drawKeypoints( gray, keypoints2, m );
		return m;
	}
	
	protected void computePosition() {
		currentPosition.x = 0;
	}
	
	public final boolean isFree() {
		return ( internalState == FREE );
	}
	
	public void stop() {
		super.stop();
		
		if( gray != null)
			gray.release();
		
		gray = null;
	}

}
